# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# ДУГИ ЭЛЛИПСА

add_library('controlP5')

#import java.awt.Rectangle
#import java.awt.geom
#import java.awt.Polygon

# размеры окна:
WIDTH = 680
HEIGHT = 550
# цвет фона:
BACKCOLOR = color(240, 248, 255)

# длина ползунка:
LENGTH = WIDTH - 50

# ширина эллипса:
w = 660
# высота эллипса:
h = 420


def setup():
    size(WIDTH, HEIGHT)
    # создаём ползунки:
    # создаём ползункик:
    global cp5
    cp5 = ControlP5(this)
    cp5.addSlider("Beg")\
        .setPosition(10, HEIGHT - 80)\
        .setSize(LENGTH, 20)\
        .setRange(0, 360)\
        .setValue(45)
    cp5.addSlider("End")\
        .setPosition(10, HEIGHT - 40)\
        .setSize(LENGTH, 20)\
        .setRange(0, 360)\
        .setValue(315)

    # размер текста:
    #textSize(24)


# РИСУЕМ ДУГУ
def draw():
    noStroke()
    fill(0, 10)
    rect(0, 0, width, height-100)
    fill(0,0,255)
    rect(0, height-100, width, 100)
    
    noFill()
    stroke(255, 5)
    strokeWeight(1.)
    ellipse(width/2., height/2.-50, w,h)
    
    # углы:
    global cp5
    st = cp5.getValue("Beg")
    fin = cp5.getValue("End")
    strokeWeight(3.)
    stroke(255)
    fill(0xFF, 0xFF, 00)
    arc(width/2., height/2.-50, w,h, radians(st), radians(fin))
    
    #fill('0xFF0000')
    #y= 476
    #text("start", 26, y)
    #text("stop", 26, y+50)
    
