# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ   
# ТРЕУГОЛЬНИКА ИЗ ТРЕУГОЛЬНИКОВ

# толщина линий:
penWidth = 2.
# длина стороны треугольника:
len= 32.


def setup():
  size(480, 440)
  background(0)
  # толщина линий:
  strokeWeight(penWidth)
  strokeJoin(ROUND)
  noFill()
  # цвет контура:
  stroke('#FFFF00')

  draw_triangles()


# ЧЕРТИМ ТРЕУГОЛЬНИКИ
def draw_triangles():
   # координаты левого угла верхнего треугольника:
   x1 = width/2.- len/2.
   y1 = 30.
   # высота треугольников:
   dy= len * sin(radians(60))
   # запоминаем начальные значения:
   yt = y1
   xt = x1
   
   # рисуем столбики из треугольников:
   for j in range(15):
     # левый столбик:
     y1 = yt + j * dy * 1.5
     x1= xt - len / 4. * 3.* j
     for i in range(1, int(15. - 1.5 * j)):
        draw_triangle(x1,y1,dy)
        y1 += dy

     # правый столбик:
     y1 = yt + j*dy*1.5
     x1 = xt + len / 4. * 3. * j
     for i in range(1, int(15.- 1.5 * j)):
       draw_triangle(x1,y1,dy)
       y1 += dy

# Чертим 1 треугольник
def draw_triangle(x, y, dy):
   x1 = x
   y1 = y;   
   x2 = x1 + len
   y2 = y1    
   x3 = x1+ len / 2.
   y3 = y1+dy    
  
   triangle(x1,y1,x2,y2,x3,y3)