# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ   
# ТРЕУГОЛЬНИКА ИЗ ТРЕУГОЛЬНИКОВ

# толщина линий:
penWidth = 2.
# длина стороны треугольника:
len= 64.


def setup():
  size(960, 880)
  background(245, 255, 250)
  # толщина линий:
  strokeWeight(penWidth)
  strokeJoin(ROUND)

  # цвет контура:
  stroke(0)

  draw_triangles()


# ЧЕРТИМ ТРЕУГОЛЬНИКИ
def draw_triangles():
   # координаты левого угла верхнего треугольника:
   x1 = width/2.- len/2.
   y1 = 30.
   # высота треугольников:
   dy= len * sin(radians(60))
   # запоминаем начальные значения:
   yt = y1
   xt = x1
   
   # рисуем столбики из треугольников:
   for j in range(15):
     # левый столбик:
     y1 = yt + j * dy * 1.5
     x1= xt - len / 4. * 3.* j
     for i in range(1, int(15. - 1.5 * j)):
        draw_triangle(x1,y1,dy)
        y1 += dy

     # правый столбик:
     y1 = yt + j*dy*1.5
     x1 = xt + len / 4. * 3. * j
     for i in range(1, int(15.- 1.5 * j)):
       draw_triangle(x1,y1,dy)
       y1 += dy

# Чертим 1 треугольник
def draw_triangle(x, y, dy):
    clr = random_color()
    fill(clr)

    x1 = x
    y1 = y;   
    x2 = x1 + len
    y2 = y1    
    x3 = x1 + len / 2.
    y3 = y1 + dy    
    
    triangle(x1,y1,x2,y2,x3,y3)
   

# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color():
    clr = color(random(32, 255), random(32, 255), random(32, 255))
    return clr
