
# размеры окна:
WIDTH = 600
HEIGHT = 300

# число прямоугольников:
N_RECT = 60


def setup():
    # создаём окно:
    size(WIDTH, HEIGHT)
    #drawRandRect()
    drawRect()


def drawRandRect():
    colorMode(RGB)
    stroke(0)
    strokeWeight(1)
    # прямоугольник -->
    # ширина:
    w = WIDTH // N_RECT
    for i in range(N_RECT):
        clr = random_color()
        fill(clr)
        rect(i * w, 0, w, HEIGHT)


# РИСУЕМ ПРЯМОУГОЛЬНИКИ
def drawRect():
    colorMode(HSB, 360, 100, 100)
    # контур:
    stroke(0)
    strokeWeight(1)
    # прямоугольник -->
    # ширина:
    w = WIDTH // N_RECT

    for i in range(N_RECT):
        clr = color(i * 360.0 / N_RECT, 100, 100)
        fill(clr)
        rect(i * w, 0, w, HEIGHT)
            
                                                
# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color():
    clr = color(random(0,255), random(0, 255), random(0, 255))
    return clr
