# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# СЛУЧАЙНЫХ ПРЯМОУГОЛЬНИКОВ

# толщина линий:
penWidth = 2.


def setup():
  size(480, 320)
  background(0)
  # толщина линий:
  strokeWeight(penWidth)
  strokeJoin(ROUND)
  rectMode(CORNERS)
  frameRate(10)


def draw():
  # задаём случайные координаты вершин прямоугольника -->
  # координаты первой вершины:     
  x1 = random(width - penWidth / 2)
  y1 = random(height - penWidth / 2)
  # координаты второй вершины:
  x2 = random(width - penWidth / 2)
  y2 = random(height - penWidth / 2)
  
  # выбираем случайный цвет линии:
  clr = random_color()
  stroke(clr)
  # выбираем случайный цвет заливки:  
  clr = random_color()
  fill(clr, 60);
  # чертим прямоугольник:
  rect(x1, y1, x2, y2, 20)


# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color():
    clr = color(random(32, 255), random(32, 255), random(32, 255))
    return clr